IPv6 support is now merged.
[rsync.git] / runtests.sh
index 2f67d456084a9ea6a5d8aaee4231d4d55aebb5fd..d6a9a482d24743d3b77c9e1c651a3ed58762981b 100755 (executable)
@@ -3,8 +3,8 @@
 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
 
 # This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU Lesser General Public License version
-# 2.1 as published by the Free Software Foundation.
+# it under the terms of the GNU General Public License version
+# 2 as published by the Free Software Foundation.
 #
 # This program is distributed in the hope that it will be useful, but
 # WITHOUT ANY WARRANTY; without even the implied warranty of
 # A scratch directory, 'testtmp', is created in the build directory to
 # hold working files.
 
-# Both this script and the Makefile have to be pretty conservative
-# about which Unix features they use.  
+# This script also uses the $loglevel environment variable.  1 is the
+# default value, and 10 the most verbose.  You can set this from the
+# Make command line.  It's also set by the build farm to give more
+# detail for failing builds.
+
+
+# NOTES FOR TEST CASES:
 
-# Exit codes: (passed back to build farm):
+# Each test case runs in its own shell. 
+
+# Exit codes from tests:
 
 #    1  tests failed
 #    2  error in starting tests
+#   77  this test skipped (random value unlikely to happen by chance, same as
+#       automake)
+
+# HOWEVER, the overall exit code to the farm is different: we return
+# the *number of tests that failed*, so that it will show up nicely in
+# the overall summary.
+
+# rsync.fns contains some general setup functions and definitions.
+
+
+# NOTES ON PORTABILITY:
+
+# Both this script and the Makefile have to be pretty conservative
+# about which Unix features they use.
+
+# We cannot count on Make exporting variables to commands, unless
+# they're explicitly given on the command line.
+
+# Also, we can't count on 'cp -a' or 'mkdir -p', although they're
+# pretty handy.
+
+# I think some of the GNU documentation suggests that we shouldn't
+# rely on shell functions.  However, the Bash manual seems to say that
+# they're in POSIX 1003.2, and since the build farm relies on them
+# they're probably working on most machines we really care about.
+
+# You cannot use "function foo {" syntax, but must instead say "foo()
+# {", or it breaks on FreeBSD.
+
+# BSD machines tend not to have "head" or "seq".
+
+# You cannot do "export VAR=VALUE" all on one line; the export must be
+# separate from the assignment.  (SCO SysV)
+
+
+
+# STILL TO DO:
+
+# We need a good protection against tests that hang indefinitely.
+# Perhaps some combination of starting them in the background, wait,
+# and kill?
+
+# Perhaps we need a common way to cleanup tests.  At the moment just
+# clobbering the directory when we're done should be enough.
+
+# If any of the targets fail, then (GNU?) Make returns 2, instead of
+# the return code from the failing command.  This is fine, but it
+# means that the build farm just shows "2" for failed tests, not the
+# number of tests that actually failed.  For more details we might
+# need to grovel through the log files to find a line saying how many
+# failed.
 
 
 set -e
 
 . "./shconfig"
 
+RUNSHFLAGS='-e'
+
+if [ -n "$loglevel" ] && [ "$loglevel" -gt 8 ]
+then
+    if set -x
+    then
+       # If it doesn't work the first time, don't keep trying.
+       RUNSHFLAGS="$RUNSHFLAGS -x"
+    fi
+fi
 
 echo "============================================================"
 echo "$0 running in `pwd`"
 echo "    rsync_bin=$rsync_bin"
 echo "    srcdir=$srcdir"
 
-if ! test -f $rsync_bin
+if test ! -f $rsync_bin
 then
     echo "rsync_bin $rsync_bin is not a file" >&2
     exit 2
 fi
 
-if ! test -d $srcdir
+if test ! -d $srcdir
 then
     echo "srcdir $srcdir is not a directory" >&2
     exit 2
 fi
 
+RSYNC="$rsync_bin"
 
-export rsync_bin
+export rsync_bin RSYNC
 
 skipped=0
 missing=0
@@ -94,44 +163,58 @@ failed=0
 scratchdir=./testtmp
 [ -d "$scratchdir" ] && rm -r "$scratchdir"
 mkdir "$scratchdir"
-
+scratchdir=`cd $scratchdir && pwd`
 echo "    scratchdir=$scratchdir"
+
 suitedir="$srcdir/testsuite"
 
-for testbase in rsync-hello hands
+export scratchdir suitedir
+
+if [ "x$whichtests" = x ]
+then
+    whichtests="*.test"
+fi
+
+for testscript in $suitedir/$whichtests
 do
-    testscript="$suitedir/$testbase.test"
-    if test \! -f "$testscript" 
-    then
-       echo "$testscript does not exist" >&2
-       missing=`expr $missing + 1`
-       continue
-    fi
+    testbase=`echo $testscript | sed 's!.*/!!'`
 
-    echo "------------------------------------------------------------"
-    echo "----- $testbase running"
+    echo "----- $testbase starting"
 
-    if sh "$testscript"
+    if sh $RUNSHFLAGS "$testscript"
     then
        echo "----- $testbase completed succesfully"
        passed=`expr $passed + 1`
-    else
-       echo "----- $testbase failed!"
-       failed=`expr $failed + 1`
-    fi 
+    else 
+       case $? in
+       77)
+           echo "----- $testbase skipped"
+           skipped=`expr $skipped + 1`
+           ;;
+       *)
+           echo "----- $testbase failed!"
+           failed=`expr $failed + 1`
+           if [ "x$nopersist" = "xyes" ]
+           then
+               exit 1
+           fi
+       esac
+    fi
 done
 
 echo '------------------------------------------------------------'
 echo "----- overall results:"
 echo "      $passed passed"
-echo "      $failed failed"
-echo "      $skipped skipped"
-echo "      $missing missing"
+[ "$failed" -gt 0 ]  && echo "      $failed failed"
+[ "$skipped" -gt 0 ] && echo "      $skipped skipped"
+[ "$missing" -gt 0 ] && echo "      $missing missing"
 echo '------------------------------------------------------------'
 
-if test $failed -gt 0
-then
-    exit 1
-else
-    exit 0
-fi
+# OK, so expr exits with 0 if the result is neither null nor zero; and
+# 1 if the expression is null or zero.  This is the opposite of what
+# we want, and if we just call expr then this script will always fail,
+# because -e is set.
+
+result=`expr $failed + $missing || true`
+echo "overall result is $result"
+exit $result